社区编辑申请
注册/登录
Go Error 嵌套到底是怎么实现的?
开发 前端
error 是一个接口类型,只需要实现 Error() 方法即可。在 Error() 方法中,就可以返回自定义结构体的任意内容。

Go Error 的设计哲学是 「Errors Are Values」。

这句话应该怎么理解呢?翻译起来挺难的。不过从源码的角度来看,好像更容易理解其背后的含义。

Go Error 源码很简单,寥寥几行:

  1. // src/builtin/builtin.go 
  2.  
  3. type error interface { 
  4.  Error() string 

error 是一个接口类型,只需要实现 Error() 方法即可。在 Error() 方法中,就可以返回自定义结构体的任意内容。

下面首先说说如何创建 error。

创建 Error

创建 error 有两种方式,分别是:

  1. errors.New();
  2. fmt.Errorf()。

errors.New()

errors.New() 的使用延续了 Go 的一贯风格,New 一下就可以了。

举一个例子:

  1. package main 
  2.  
  3. import ( 
  4.  "errors" 
  5.  "fmt" 
  6.  
  7. func main() { 
  8.  err := errors.New("这是 errors.New() 创建的错误"
  9.  fmt.Printf("err 错误类型:%T,错误为:%v\n", err, err) 
  10.  
  11. /* 输出 
  12. err 错误类型:*errors.errorString,错误为:这是 errors.New() 创建的错误 
  13. */ 

这段代码唯一让人困惑的地方可能就是错误类型了,但没关系。只要看一下源码,就瞬间迎刃而解。

源码如下:

  1. // src/errors/errors.go 
  2.  
  3. // New returns an error that formats as the given text. 
  4. // Each call to New returns a distinct error value even if the text is identical. 
  5. func New(text string) error { 
  6.  return &errorString{text} 
  7.  
  8. // errorString is a trivial implementation of error. 
  9. type errorString struct { 
  10.  s string 
  11.  
  12. func (e *errorString) Error() string { 
  13.  return e.s 

可以看到,errorString 是一个结构体,实现了 Error() 方法,New 函数直接返回 errorString 指针。

这种用法很简单,但不实用。假如我还想返回程序的上下文信息,它就没辙了。

下面看第二种方式。

fmt.Errorf()

还是先看一个例子:

  1. package main 
  2.  
  3. import ( 
  4.  "database/sql" 
  5.  "fmt" 
  6.  
  7. func foo() error { 
  8.  return sql.ErrNoRows 
  9.  
  10. func bar() error { 
  11.  return foo() 
  12.  
  13. func main() { 
  14.  err := bar() 
  15.  if err == sql.ErrNoRows { 
  16.   fmt.Printf("data not found, %+v\n", err) 
  17.   return 
  18.  } 
  19.  if err != nil { 
  20.   fmt.Println("Unknown error"
  21.  } 
  22.  
  23. /* 输出 
  24. data not found, sql: no rows in result set 
  25. */ 

这个例子输出了我们想要的结果,但是还不够。

一般情况下,我们会通过使用 fmt.Errorf() 函数,附加上我们想添加的文本信息,使返回内容更明确,处理起来更灵活。

所以,foo() 函数会改成下面这样:

  1. func foo() error { 
  2.    return fmt.Errorf("foo err, %v", sql.ErrNoRows) 

这时问题就出现了,经过 fmt.Errorf() 的封装,原始 error 类型发生了改变,这就导致 err == sql.ErrNoRows 不再成立,返回信息变成了 Unknown error。

如果想根据返回的 error 类型做不同处理,就无法实现了。

因此,Go 1.13 为我们提供了 wrapError 来处理这个问题。

Wrap Error

看一个例子:

  1. package main 
  2.  
  3. import ( 
  4.  "fmt" 
  5.  
  6. type myError struct{} 
  7.  
  8. func (e myError) Error() string { 
  9.  return "Error happended" 
  10.  
  11. func main() { 
  12.  e1 := myError{} 
  13.  e2 := fmt.Errorf("E2: %w", e1) 
  14.  e3 := fmt.Errorf("E3: %w", e2) 
  15.  fmt.Println(e2) 
  16.  fmt.Println(e3) 
  17.  
  18. /* output 
  19. E2: Error happended 
  20. E3: E2: Error happended 
  21. */ 

乍一看好像好没什么区别,但背后的实现原理却并不相同。

Go 扩展了 fmt.Errorf() 函数,增加了一个 %w 标识符来创建 wrapError。

  1. // src/fmt/errors.go 
  2.  
  3. func Errorf(format string, a ...interface{}) error { 
  4.  p := newPrinter() 
  5.  p.wrapErrs = true 
  6.  p.doPrintf(format, a) 
  7.  s := string(p.buf) 
  8.  var err error 
  9.  if p.wrappedErr == nil { 
  10.   err = errors.New(s) 
  11.  } else { 
  12.   err = &wrapError{s, p.wrappedErr} 
  13.  } 
  14.  p.free() 
  15.  return err 

当使用 w% 时,函数会返回 &wrapError{s, p.wrappedErr},wrapError 结构体定义如下:

  1. // src/fmt/errors.go 
  2.  
  3. type wrapError struct { 
  4.  msg string 
  5.  err error 
  6.  
  7. func (e *wrapError) Error() string { 
  8.  return e.msg 
  9.  
  10. func (e *wrapError) Unwrap() error { 
  11.  return e.err 

实现了 Error() 方法,说明它是一个 error,而 Unwrap() 方法是为了获取被封装的 error。

  1. // src/errors/wrap.go 
  2.  
  3. func Unwrap(err error) error { 
  4.  u, ok := err.(interface { 
  5.   Unwrap() error 
  6.  }) 
  7.  if !ok { 
  8.   return nil 
  9.  } 
  10.  return u.Unwrap() 

它们之间的关系是这样的:

图片

因此,我们可以使用 w% 将上文中的程序进行改造,使其内容输出更丰富。

如下:

  1. package main 
  2.  
  3. import ( 
  4.  "database/sql" 
  5.  "errors" 
  6.  "fmt" 
  7.  
  8. func bar() error { 
  9.  if err := foo(); err != nil { 
  10.   return fmt.Errorf("bar failed: %w", foo()) 
  11.  } 
  12.  return nil 
  13.  
  14. func foo() error { 
  15.  return fmt.Errorf("foo failed: %w", sql.ErrNoRows) 
  16.  
  17. func main() { 
  18.  err := bar() 
  19.  if errors.Is(err, sql.ErrNoRows) { 
  20.   fmt.Printf("data not found,  %+v\n", err) 
  21.   return 
  22.  } 
  23.  if err != nil { 
  24.   fmt.Println("Unknown error"
  25.  } 
  26.  
  27. /* output 
  28. data not found,  bar failed: foo failed: sql: no rows in result set 
  29. */ 

终于有了让人满意的输出结果,每个函数都增加了必要的上下文信息,而且也符合对错误类型的判断。

errors.Is() 函数用来判断 err 以及其封装的 error 链中是否包含目标类型。这也就解决了上文提出的无法判断错误类型的问题。

后记

其实,Go 目前对 Error 的处理方式也是充满争议的。不过,官方团队正在积极和社区交流,提出改进方法。相信在不久的将来,一定会找到更好的解决方案。

现阶段来说,大部分团队可能会选择 github.com/pkg/errors 包来进行错误处理。如果感兴趣的话,可以学学看。

 

责任编辑:姜华 来源: AlwaysBeta
相关推荐

2022-01-14 17:01:44

2022-05-19 14:14:26

go语言限流算法

2022-06-27 08:07:13

Go语言互斥锁

2022-05-22 13:55:30

Go 语言

2022-06-30 09:07:52

2022-04-27 15:18:30

Go 语言API排序算法

2022-05-25 10:04:43

Go编程

2022-06-06 00:25:09

Golangpanic死锁

2022-05-05 09:02:24

Go函数调用栈

2022-04-13 09:57:24

Go语言C语言程序开发

2022-06-06 15:18:41

开源GiteaDrone

2022-05-26 08:53:47

2022-04-10 23:02:08

GoRust语言

2022-05-30 07:36:54

vmstoragevmselect

2022-02-23 15:30:28

SpringBoot后端流程

2022-01-05 08:00:00

框架Golang开源

2022-05-12 15:25:16

恶意软件网络攻击

2022-06-20 07:32:17

2022-06-01 09:25:16

2010-02-02 17:20:44

C++ switch-

同话题下的热门内容

哪个版本的JVM最快?无代码软件发展简史及未来趋势携程基于 GraphQL 的前端 BFF 服务开发实践为什么会存在 1px 问题?怎么解决?一文搞定常考Vue-Router知识点EcmaScript 2022 正式发布,有哪些新特性?一文详解|增长那些事儿远程医疗:优势、前景和现有IT解决方案

编辑推荐

太厉害了,终于有人能把TCP/IP协议讲的明明白白了!牛人5次面试腾讯不成功的经验HBase原理–所有Region切分的细节都在这里了Javascript如何监听页面刷新和关闭事件如何搭建一个HTTPS服务端
我收藏的内容
点赞
收藏

51CTO技术栈公众号